"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var sids_1 = require("flex-dev-utils/dist/sids");
var baseClient_1 = __importDefault(require("./baseClient"));
var services_1 = __importDefault(require("./services"));
var DeploymentClient = /** @class */ (function (_super) {
    __extends(DeploymentClient, _super);
    function DeploymentClient(auth, serviceSid, environmentSid) {
        var _this = _super.call(this, auth, services_1.default.getBaseUrl() + "/Services/" + serviceSid + "/Environments/" + environmentSid) || this;
        /**
         * Creates a new deployment
         *
         * @param buildSid  the build sid
         */
        _this.create = function (buildSid) {
            if (!sids_1.isSidOfType(buildSid, sids_1.SidPrefix.BuildSid)) {
                throw new Error(buildSid + " is not of type " + sids_1.SidPrefix.BuildSid);
            }
            return _this.http
                .post(DeploymentClient.BaseUri, { BuildSid: buildSid });
        };
        if (!sids_1.isSidOfType(serviceSid, 'ZS')) {
            throw new Error("ServiceSid " + serviceSid + " is not valid");
        }
        if (!sids_1.isSidOfType(environmentSid, 'ZE')) {
            throw new Error("EnvironmentSid " + environmentSid + " is not valid");
        }
        return _this;
    }
    DeploymentClient.BaseUri = 'Deployments';
    return DeploymentClient;
}(baseClient_1.default));
exports.default = DeploymentClient;
//# sourceMappingURL=deployments.js.map