"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var baseClient_1 = __importDefault(require("./baseClient"));
var ServiceClient = /** @class */ (function (_super) {
    __extends(ServiceClient, _super);
    function ServiceClient(auth) {
        var _this = _super.call(this, auth, ServiceClient.getBaseUrl()) || this;
        /**
         * Fetches an instance of Serverless service
         *
         * @param sid the service sid
         */
        _this.get = function (sid) {
            return _this.http
                .get(ServiceClient.BASE_URI + "/" + sid);
        };
        /**
         * Fetches the default {@link Service}.
         */
        _this.getDefault = function () {
            return _this.list()
                .then(function (resource) { return resource.services.find(function (s) { return s.unique_name === 'default'; }); })
                .then(function (service) {
                if (!service) {
                    return _this.create();
                }
                return service;
            });
        };
        /**
         * Creates a {@link Service} with unique name `default`
         */
        _this.create = function () {
            return _this.http
                .post(ServiceClient.BASE_URI, ServiceClient.NewService);
        };
        /**
         * Fetches the list of {@link Service}
         */
        _this.list = function () {
            return _this.http
                .get(ServiceClient.BASE_URI);
        };
        return _this;
    }
    ServiceClient.BASE_URI = 'Services';
    ServiceClient.NewService = {
        UniqueName: 'default',
        FriendlyName: 'Flex Plugins Default Service',
    };
    /**
     * Returns the base URL
     */
    ServiceClient.getBaseUrl = function (baseUrl) {
        if (baseUrl === void 0) { baseUrl = 'serverless'; }
        return baseClient_1.default.getBaseUrl(baseUrl, ServiceClient.version);
    };
    ServiceClient.version = 'v1';
    return ServiceClient;
}(baseClient_1.default));
exports.default = ServiceClient;
//# sourceMappingURL=services.js.map