#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var flex_dev_utils_1 = require("flex-dev-utils");
var flex_dev_utils_2 = require("flex-dev-utils");
var updateNotifier_1 = require("flex-dev-utils/dist/updateNotifier");
var fs_1 = require("fs");
var marked_1 = require("flex-dev-utils/dist/marked");
var path_1 = require("path");
var run_1 = require("./utils/run");
updateNotifier_1.checkForUpdate();
var spawnScript = function () {
    var argv = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        argv[_i] = arguments[_i];
    }
    return __awaiter(void 0, void 0, void 0, function () {
        var dir, files, scripts, scriptIndex, script, options, docPath, nodeArgs, scriptPath, scriptArgs, processArgs, exitCode;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dir = path_1.dirname(__filename);
                    files = fs_1.readdirSync(path_1.join(dir, 'scripts'));
                    scripts = files
                        .filter(function (f) {
                        var ext = f.split('.').pop();
                        return ext === 'js' || ext === 'ts';
                    })
                        .map(function (f) { return f.split('.')[0]; })
                        .filter(function (f) { return f !== 'run'; });
                    scripts = __spread(new Set(scripts));
                    scriptIndex = argv.findIndex(function (x) { return scripts.includes(x); });
                    script = scriptIndex !== -1 && argv[scriptIndex];
                    if (!script) {
                        options = flex_dev_utils_2.logger.colors.blue(scripts.join(', '));
                        flex_dev_utils_2.logger.error("Unknown script '" + script + "'; please choose from one of: " + options + ".");
                        return [2 /*return*/, process.exit(1)];
                    }
                    // Print help doc and quit
                    if (argv.includes('--help') && script) {
                        docPath = path_1.join(dir, '../docs', script) + '.md';
                        if (!fs_1.existsSync(docPath)) {
                            flex_dev_utils_2.logger.warning("No documentation was found for " + script);
                            return [2 /*return*/, process.exit(1)];
                        }
                        marked_1.render(docPath);
                        return [2 /*return*/, process.exit(0)];
                    }
                    nodeArgs = scriptIndex > 0 ? argv.slice(0, scriptIndex) : [];
                    scriptPath = require.resolve("./scripts/" + script);
                    scriptArgs = argv.slice(scriptIndex + 1);
                    processArgs = nodeArgs.concat(scriptPath).concat(scriptArgs);
                    // Temp disallow version while we figure this out
                    if (script !== 'test') {
                        processArgs.push('--disallow-versioning');
                    }
                    return [4 /*yield*/, flex_dev_utils_1.spawn('node', processArgs)];
                case 1:
                    exitCode = (_a.sent()).exitCode;
                    run_1.exit(exitCode, argv);
                    return [2 /*return*/];
            }
        });
    });
};
exports.default = spawnScript;
//# sourceMappingURL=index.js.map