"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var flex_dev_utils_1 = require("flex-dev-utils");
var instructionToReinstall_1 = __importDefault(require("./instructionToReinstall"));
var preFlightByPass_1 = __importDefault(require("./preFlightByPass"));
/**
 * Error message if we fail to sync the public/ directory
 *
 * @param err   the error message
 * @param skip  whether pre flight skip flag is set
 */
exports.default = (function (err, skip) {
    var link = flex_dev_utils_1.logger.coloredStrings.link;
    var scriptName = flex_dev_utils_1.logger.coloredStrings.name('flex-plugin-scripts');
    flex_dev_utils_1.logger.newline();
    flex_dev_utils_1.logger.newline();
    flex_dev_utils_1.logger.error('There might be a problem with your project file hierarchy.');
    flex_dev_utils_1.logger.newline();
    flex_dev_utils_1.logger.info("The " + scriptName + " failed to copy " + link('index.html') + " into " + link('public/') + " directory.");
    flex_dev_utils_1.logger.newline();
    instructionToReinstall_1.default();
    preFlightByPass_1.default(skip);
    flex_dev_utils_1.logger.newline();
});
//# sourceMappingURL=publicDirCopyFailed.js.map