interface Package {
    version: string;
    dependencies: object;
}
/**
 * Checks appConfig exists
 *
 * @private
 */
export declare const _checkAppConfig: () => undefined;
/**
 * Checks that craco-config path exists
 * @private
 */
export declare const _checkCracoConfig: () => undefined;
/**
 * Syncs required files in public/ dir
 *
 * @param allowSkip whether to allow skip
 * @private
 */
export declare const _checkPublicDirSync: (allowSkip: boolean) => undefined;
/**
 * Checks the version of external libraries and exists if customer is using another version
 *
 * allowSkip  whether to allow skip
 * @private
 */
export declare const _checkExternalDepsVersions: (allowSkip: boolean, allowReact: boolean) => void;
/**
 * Checks the version of external libraries and exists if customer is using another version
 *
 * @param flexUIPkg   the flex-ui package.json
 * @param allowSkip   whether to allow skip
 * @param allowReact  whether to allow unbundled react
 * @param name        the package to check
 * @private
 */
export declare const _verifyPackageVersion: (flexUIPkg: Package, allowSkip: boolean, allowReact: boolean, name: string) => undefined;
/**
 * Returns the content of src/index
 * @private
 */
export declare const _readIndexPage: () => string;
/**
 * Checks how many plugins this single JS bundle is exporting
 * You can only have one plugin per JS bundle
 * @private
 */
export declare const _checkPluginCount: () => undefined;
/**
 * Runs pre-start/build checks
 */
declare const checkStart: () => Promise<void>;
export default checkStart;
