"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._replacePlugins = exports._requirePackages = exports._getPortAndUrl = exports._getPort = void 0;
var flex_dev_utils_1 = require("flex-dev-utils");
var path_1 = require("path");
var run_1 = __importDefault(require("../../utils/run"));
var pluginServer_1 = __importDefault(require("../start/pluginServer"));
/**
 * Extracts port from a localhost url
 *
 * @param url the localhost url
 * @private
 */
exports._getPort = function (url) {
    var matches = url.match(/localhost:(\d*)/);
    if (!matches) {
        throw new flex_dev_utils_1.FlexPluginError("Could not find a local port on url " + url);
    }
    return matches[1];
};
/**
 * Finds the port and localhost url from the argv
 *
 * @param argv
 * @private
 */
exports._getPortAndUrl = function () {
    var argv = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        argv[_i] = arguments[_i];
    }
    var url = argv.find(function (a) { return a.indexOf('localhost:') !== -1; });
    if (!url) {
        throw new flex_dev_utils_1.FlexPluginError('No localhost server was found running.');
    }
    return {
        url: url,
        port: exports._getPort(url),
    };
};
/**
 * requires packages
 *
 * @param pluginsPath   the plugins path
 * @param pkgPath       the package path
 * @private
 */
/* istanbul ignore next */
exports._requirePackages = function (pluginsPath, pkgPath) {
    var plugins = require(pluginsPath);
    var pkg = require(pkgPath);
    return {
        plugins: plugins,
        pkg: pkg,
    };
};
/**
 * Replaces the port in plugins.json and re-writes ito the file
 *
 * @param port  the port to update to
 * @private
 */
exports._replacePlugins = function (port) {
    var pluginsPath = path_1.join(process.cwd(), 'public', 'plugins.json');
    var pkgPath = path_1.join(process.cwd(), 'package.json');
    var _a = exports._requirePackages(pluginsPath, pkgPath), plugins = _a.plugins, pkg = _a.pkg;
    var pluginIndex = plugins.findIndex(function (p) { return p.src.indexOf(pkg.name) !== -1; });
    var existingPort = exports._getPort(plugins[pluginIndex].src);
    // Replace port and re-write to file
    plugins[pluginIndex].src = plugins[pluginIndex].src.replace(existingPort, port);
    flex_dev_utils_1.fs.writeFileSync(pluginsPath, JSON.stringify(plugins, null, 2));
};
/**
 * Dynamically updates the plugins.json file, and then opens the browser
 * @param argv
 */
var browser = function () {
    var argv = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        argv[_i] = arguments[_i];
    }
    return __awaiter(void 0, void 0, void 0, function () {
        var _a, url, port;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = exports._getPortAndUrl.apply(void 0, __spread(argv)), url = _a.url, port = _a.port;
                    exports._replacePlugins(port);
                    // Now open browser
                    return [4 /*yield*/, flex_dev_utils_1.open(url)];
                case 1:
                    // Now open browser
                    _b.sent();
                    // Run a dev-server plugin service to talk with Flex plugin service
                    pluginServer_1.default(port);
                    return [2 /*return*/];
            }
        });
    });
};
run_1.default(browser);
exports.default = browser;
//# sourceMappingURL=browser.js.map