"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._generatePluginServiceConfig = exports._server = exports._rebasePlugins = exports._getRemotePlugins = exports._getHeaders = exports._getLocalPlugins = void 0;
var flex_dev_utils_1 = require("flex-dev-utils");
var fs_1 = __importStar(require("flex-dev-utils/dist/fs"));
var strings_1 = require("flex-dev-utils/dist/strings");
var path_1 = require("path");
var http_1 = __importDefault(require("http"));
var https_1 = __importDefault(require("https"));
/* istanbul ignore next */
var pluginsJsonPath = path_1.join(process.cwd(), 'public/plugins.json');
/* istanbul ignore next */
var pluginsServiceConfigPath = path_1.join(process.cwd(), 'public', 'pluginsService.js');
/**
 * Returns local plugins from  public/plugins.json
 * @private
 */
/* istanbul ignore next */
exports._getLocalPlugins = function () { return JSON.parse(fs_1.readFileSync(pluginsJsonPath)); };
/**
 * Generates the response headers
 *
 * @param port  the port the browser will be running on
 * @private
 */
exports._getHeaders = function (port) { return ({
    'Access-Control-Allow-Origin': "http://localhost:" + port,
    'Access-Control-Allow-Methods': 'GET',
    'Access-Control-Allow-Headers': 'Content-Type, X-Flex-Version, X-Flex-JWE',
    'Access-Control-Allow-Credentials': 'true',
    'Content-Type': 'application/json',
}); };
/**
 * Fetches the Plugins from Flex
 *
 * @param token     the JWE Token
 * @param version   the Flex version
 */
/* istanbul ignore next */
exports._getRemotePlugins = function (token, version) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve, reject) {
                var headers = {
                    'X-Flex-JWE': token,
                };
                if (version) {
                    headers['X-Flex-Version'] = version;
                }
                var options = {
                    hostname: 'flex.twilio.com',
                    port: 443,
                    path: '/plugins',
                    method: 'GET',
                    headers: headers,
                };
                https_1.default
                    .request(options, function (res) {
                    var data = [];
                    res.on('data', function (chunk) { return data.push(chunk); });
                    res.on('end', function () { return resolve(JSON.parse(Buffer.concat(data).toString())); });
                })
                    .on('error', reject)
                    .end();
            })];
    });
}); };
/**
 * Rebase plugins with local plugins
 * @param remotePlugins   the plugins returned from Flex
 * @private
 */
exports._rebasePlugins = function (remotePlugins) {
    var pkg = fs_1.readPackageJson();
    return exports._getLocalPlugins()
        .map(function (plugin) {
        // Local main (plugin) we are running
        if (plugin.name === pkg.name) {
            return plugin;
        }
        // Plugin is disabled - do not load it
        if (!plugin.enabled) {
            return null;
        }
        // Load remote plugin from Flex
        if (plugin.remote === true) {
            return remotePlugins.find(function (p) { return p.name === plugin.name; });
        }
        // Backward compatibility / current way of running multiple local plugins
        if (plugin.src) {
            return plugin;
        }
        return null;
    })
        .filter(Boolean);
};
/**
 * Basic server to fetch plugins from Flex and return to the local dev-server
 * @param browserPort  the port of browser
 * @private
 */
exports._server = function (browserPort) { return function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
    var responseHeaders, headers, method, url, jweToken, flexVersion, remotePlugins, plugins, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                responseHeaders = exports._getHeaders(browserPort);
                headers = req.headers, method = req.method, url = req.url;
                if (method === 'OPTIONS') {
                    res.writeHead(200, responseHeaders);
                    return [2 /*return*/, res.end()];
                }
                if (method !== 'GET' || url !== '/plugins') {
                    res.writeHead(404, responseHeaders);
                    return [2 /*return*/, res.end('Route not found')];
                }
                jweToken = headers['x-flex-jwe'];
                flexVersion = headers['x-flex-version'];
                if (!jweToken) {
                    res.writeHead(400, responseHeaders);
                    return [2 /*return*/, res.end('No X-Flex-JWE was provided')];
                }
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4 /*yield*/, exports._getRemotePlugins(jweToken, flexVersion)];
            case 2:
                remotePlugins = _a.sent();
                plugins = exports._rebasePlugins(remotePlugins);
                res.writeHead(200, responseHeaders);
                res.end(JSON.stringify(plugins));
                return [3 /*break*/, 4];
            case 3:
                err_1 = _a.sent();
                res.writeHead(500, responseHeaders);
                res.end(err_1);
                return [3 /*break*/, 4];
            case 4: return [2 /*return*/];
        }
    });
}); }; };
/**
 * Generates the pluginsService.js
 *
 * @param port  the port the local dev-server is running
 * @private
 */
exports._generatePluginServiceConfig = function (port) {
    var url = "'http://localhost:" + port + "/plugins';";
    var str = strings_1.multilineString('// This file is auto-generated', 'if (appConfig.pluginService.url === null) {', "  appConfig.pluginService.url = " + url, '}');
    fs_1.default.writeFileSync(pluginsServiceConfigPath, str);
};
/**
 * Runs a local dev-server to proxy requests to Flex plugin service
 * @param browserPort   the port the browser is running
 */
/* istanbul ignore next */
var pluginServer = function (browserPort) { return __awaiter(void 0, void 0, void 0, function () {
    var port, server;
    return __generator(this, function (_a) {
        port = Number(browserPort);
        exports._generatePluginServiceConfig(port + 1);
        server = http_1.default
            .createServer(exports._server(port))
            .listen(port + 1, '127.0.0.1', function () {
            flex_dev_utils_1.logger.debug("Local plugin server running on port " + (port + 1));
        });
        process.on('exit', function () { return server.close(); });
        return [2 /*return*/];
    });
}); };
exports.default = pluginServer;
//# sourceMappingURL=pluginServer.js.map