"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var flex_dev_utils_1 = require("flex-dev-utils");
var path_1 = require("path");
var fs_1 = require("flex-dev-utils/dist/fs");
var packageJson = fs_1.readPackageJson();
var packageName = packageJson.name;
var buildDir = path_1.join(process.cwd(), 'build');
var assetBaseUrl = "/plugins/" + packageName + "/%PLUGIN_VERSION%";
if (packageName.substr(0, 6) !== 'plugin') {
    throw new flex_dev_utils_1.FlexPluginError("Package name \"" + packageName + "\" does not start with \"plugin\".");
}
exports.default = {
    buildDir: buildDir,
    packageName: packageName,
    version: packageJson.version,
    localBundlePath: path_1.join(buildDir, packageName) + ".js",
    localSourceMapPath: path_1.join(buildDir, packageName) + ".js.map",
    appConfig: path_1.join(process.cwd(), 'public', 'appConfig.js'),
    assetBaseUrlTemplate: assetBaseUrl,
};
//# sourceMappingURL=paths.js.map