"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPackageVersion = exports.resolve = exports.nodeModulesPath = void 0;
var path_1 = require("path");
exports.nodeModulesPath = path_1.join(process.cwd(), 'node_modules');
/**
 * Resolves the path to the given module. Appends the process.cwd node_modules as well
 *
 * @param module the module to resolve
 */
/* istanbul ignore next */
exports.resolve = function (module) {
    var paths = require.main && require.main.paths || [];
    if (!paths.includes(exports.nodeModulesPath)) {
        paths.push(exports.nodeModulesPath);
    }
    return require.resolve(module, { paths: paths });
};
/**
 * Returns the package.json version field of the package
 * @param name  the package
 */
/* istanbul ignore next */
exports.getPackageVersion = function (name) {
    return require(path_1.join(exports.nodeModulesPath, name, 'package.json')).version;
};
//# sourceMappingURL=require.js.map